
cbuffer PMV
{
	mat4	hu_mPMVMatrix;
};

struct VIn
{
	vec4	a_vPosition: POSITION;
	vec2	a_vTexCoord: TEXCOORD;
};

struct PIn
{
    vec4	v_vPosition: SV_POSITION;
	vec2	v_vTexCoord: TEXCOORD;
	vec3	v_vNormal: NORMAL;
};

PIn main(VIn input)
{
    PIn output;

    output.v_vPosition = mul(hu_mPMVMatrix, input.a_vPosition);
	output.v_vTexCoord = input.a_vTexCoord;
	output.v_vNormal = 0.001*input.a_vPosition.xyz;

    return output;
}

