
// ------- UNIFORMS (SHADER CONSTS) -------
cbuffer PMV
{
	mat4	hu_mPMVMatrix;
};
mat4		hu_mMMatrix;

// ------- ATTRIBUTES (VERTEX BUFFER DATA) -------
struct VIn
{
	vec4	a_vPosition0: POSITION;
	vec2	a_vTexCoord0: TEXCOORD;
};

// ------- INTERPOLATORS (SHADER OUTPUTS) -------
struct PIn
{
	vec4	v_vPosition: SV_POSITION;
	vec2	v_vTexCoord: TEXCOORD;
	vec3	v_vNormal: NORMAL;
};

PIn main(VIn input)
{
    PIn output;
	output.v_vPosition = mul(hu_mPMVMatrix, input.a_vPosition0);
	vec4 vWorld = mul(hu_mMMatrix, input.a_vPosition0);
	output.v_vTexCoord = input.a_vTexCoord0;
	output.v_vNormal = 0.001*vWorld.xyz;

	return output;
}
