
// ------- UNIFORMS (SHADER CONSTS) -------
cbuffer PMV
{
	mat4 hu_mPMVMatrix;
};

// ------- ATTRIBUTES (VERTEX BUFFER DATA) -------
struct VIn
{
	vec4	position: POSITION;
	vec2	uv: TEXCOORD;
};

// ------- INTERPOLATORS (SHADER OUTPUTS) -------
struct PIn
{
    vec4	position: SV_POSITION;
	vec2	uv: TEXCOORD;
};

// ------- FUNCTIONS ------- 
PIn main(VIn input)
{
	PIn output;
	output.position = mul(hu_mPMVMatrix, input.position);
	output.uv = input.uv;

	return output;
}
